<h1>컴포넌트</h1> 독립적인 단위모듈

컴포넌트의 기능은 단순 템플릿 이상이다. 

선언방식은 두가지로 함수형 컴포넌트와 클래스형 컴포넌트이다.



함수형 컴포넌트

```
import React from 'react'

function App() {
  const name = '리액트';
  return <div className="react">{name}</div>;
}
```

클래스형 컴포넌트

```
import React, { Component } from 'react'; // React.Componet로 extends하면 Component안해도됨

class App extends Component {
  render() {
    const name = 'react';
    return <div className="react">{name}</div>;
  }
}
```

공통적으로 react 모듈 import, 클래스는 render 함수 필요, 함수형은 바로 return 

---

클래스형 컴포넌트의 경우 state 기능 및 라이프사이클 사용할 수 있음 (임의 메소드도 정의가능)

render 필수, JSX를 반환해야함

---

둘중 어느상황에 함수형 컴포넌트 사용할까?

클래스형 컴포넌트보다 선언하기 편함, 메모리 자원 덜사용, 빌드한후 베포할때 결과물의 파일크기가

더작음 -> state랑 라이프사이클 API사용 불가능했으나 Hooks도입후 해결

이제 함수형컴포넌트와 Hooks를 사용하도록 권장

---

```
export default MyComponent;
```

다른파일에서 이파일 import할때 클래스 불러오도록 설정

---

props -> properties줄임표현 컴포넌트의 속성을 설정할때 사용하는 요소

props의 값은 해당 컴포넌트를 불러와 사용하는 부모 컴포넌트에서 설정



props 기본설정 defaultProps

props.children 부모 컴포넌트 태그 사이에 작성한 문자열 

---

필수 props를 지정하거나 props타입을 지정할때 propTypes 사용

```
import PropTypes from 'prop-types';

컴포넌트명.propTypes = {
 name: PropTypes.string 문자열 형태 전달
}
```

```
컴포넌트.propTypes = {
 favoriteNumber: PropTypes.number.isRequired
}
```

태그 사이 내용을 보여주는 children

```
import React from 'react';
import MyComponent from './MyComponent';

const App = () => {
	return <MyComponent>리액트</MyComponent>
}
export default App;
```

리액트라는 컨텐츠를 MyComponent 컴포넌트에 내려?주고 MyComponent내부에선 props.children으로 값을 봄

---

state  ''컴포넌트 내부에서 바뀔 수 있는 값''

props는 컴포넌트가 사용되는 과정에서 부모 컴포넌트가 설정하는 값 (읽기전용)

---

construcotor 메소드에서 선언

```
state = {
 number :0,
 fixedNumber:0
}
```

this.setState 상태가 비동기적으로 업데이트

```
this.setState((prevState, props)=>{
 return{
 업데이트 하고싶은내용
 }
})
```

this.setState가 끝난후 특정 작업실행하기

두번째 파라미터로 콜백함수 등록

---

함수형 컴포넌트에서 useState 사용하기

useState 함수의 인자에는 상태의 초깃값 (객체형태 아니여도 괜찮음)

const [one, two] = useState('')

배열의 첫번째 원소 = 현재 상태

두번째 원소 상태를 바꾸어주는 함수 (세터함수)

한 컴포넌트에서 useState여러번 사용가능

---

state 사용할 때 주의사항

state값을 바꿀때는 setState 또는 useState를 통해 전달받은 세터 함수를 사용할것(직접변경x)



객체나 배열을 업데이트할때는 사본을 만들고 사본에 값을 업데이트 한후 사본의 상태를

setState혹은 세터함수를 통해 업데이트

---

정리

컴포넌트를 만들어서 (function, class) 내보내고 불러오기 (import, export) props 및 state사용

props와 state 둘다 컴포넌트에서 사용하거나 렌더링할 데이터를 담고있으나

역할은 매우 다르다 props는 부모 컴포넌트가 설정하고 , state는 컴포넌트 자체적으로 지닌 값으로

컴포넌트 내부에서 값을 업데이트

props를 사용한다고 값이 무조건 고정적이지는 않음 부모 컴포넌트의 state를 자식컴포넌트의 props로 전달하고,

자식 컴포넌트에서 특정 이벤트 발생시 부모 컴포넌트의 메서드를 호출하면 prpops도 유동적으로 사용가능



클래스형 컴포넌트 -> state 함수형 컴포넌트 useState

